# Welcome to the Team!

We're delighted that you're joining us. We've prepared this onboarding documentation to help you get set up with our development environment and become familiar with our coding practices and workflows.

## Purpose of This Document

The purpose of these onboarding documents is to provide you with all the necessary information and guidelines that will help you get started with our development setup quickly and effectively.

## What Does the Onboarding Document Cover?

These documents cover everything from configuring Git, installing necessary software and tools, setting up your local development environment, understanding our workflow, to troubleshooting common issues and adhering to our coding standards.

1. [**Software Setup**](./setup.md): You'll find step-by-step instructions for installing all necessary software and tools, such as Visual Studio Code, Python, and various VSCode extensions that we use for our Python development, as well as, instruction on how to set up Git for our project.

2. [**Development Environment**](./development-environment.md): This part guides you through the process of setting up your local development environment, including configuring Python interpreter in VSCode, setting up debugging and tracing, and using Jupyter Notebooks within VSCode.

3. [**Workflow Overview**](./workflow.md): We explain our code development process, version control practices, and how we handle pair programming and code reviews.

4. [**Troubleshooting Guide**](.troubleshooting.md): This guide provides useful tips for debugging and troubleshooting issues using tools like VSCode's debugger and Python's pdb.

5. [**Coding Standard**](./style.md): We also cover our coding standards, including code formatting and linting standards, testing practices, and documentation guidelines.

## How to Use These Documents

We recommend going through these documents in the order they are presented, especially if you're new to some of the tools and technologies we use. If you're already familiar with some parts, feel free to jump ahead.

Remember, everyone on our team is here to help. If you have any questions or run into any problems as you go through these documents, don't hesitate to ask for help.

Welcome aboard, we're excited to have you on our team!
